From c40253cb4e34b947994a4c766cf58df84552fdb2 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:02 +0000
Subject: [PATCH 888/1001] Fix usage of the session


---

diff --git a/hubs/app.py b/hubs/app.py
index 1cc6c68..c24a9e0 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -67,28 +67,34 @@ def check_auth():
     flask.g.fedmsg_config = fedmsg_config
 
     if OIDC.user_loggedin:
-        if not hasattr(flask.session, 'auth') or not flask.session.auth:
-            flask.session.auth = munch.Munch(
-                fullname=OIDC.user_getfield('name'),
-                nickname=(OIDC.user_getfield('nickname') or
-                          OIDC.user_getfield('sub')),
-                email=OIDC.user_getfield('email'),
-                timezone=OIDC.user_getfield('zoneinfo'),
+        if "auth" not in flask.session or not flask.session["auth"]:
+            user_info = OIDC.user_getinfo([
+                "name", "nickname", "sub", "email", "zoneinfo", "cla",
+                "groups",
+                ])
+            flask.session["auth"] = dict(
+                fullname=user_info['name'],
+                nickname=(user_info['nickname'] or user_info['sub']),
+                email=user_info['email'],
+                timezone=user_info['zoneinfo'],
                 cla_done=('http://admin.fedoraproject.org/accounts/cla/done'
-                          in OIDC.user_getfield('cla')),
-                groups=OIDC.user_getfield('groups'),
+                          in user_info['cla']),
+                groups=user_info['groups'],
                 logged_in=True,
             )
-            flask.session.auth.avatar = username2avatar(
-                flask.session.auth.nickname)
-
-            user = hubs.models.User.get_or_create(
-                flask.g.db, username=flask.session.auth.nickname,
-                fullname=flask.session.auth.fullname)
-            flask.session.auth.user = user
-        flask.g.auth = flask.session.auth
+            flask.session["auth"]["avatar"] = username2avatar(
+                flask.session["auth"]["nickname"])
+            # Changes on mutable objects aren't picked up:
+            # http://flask.pocoo.org/docs/0.12/api/#flask.session.modified
+            flask.session.modified = True
+        flask.g.auth = munch.Munch(**flask.session["auth"])
+        user = hubs.models.User.get_or_create(
+            flask.g.db, username=flask.session["auth"]["nickname"],
+            fullname=flask.session["auth"]["fullname"])
+        flask.g.user = user
     else:
-        flask.g.auth = munch.Munch(logged_in=False, user=None)
+        flask.g.auth = munch.Munch(logged_in=False)
+        flask.g.user = None
 
 
 # Register widgets
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index a57c0c1..15051a6 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -138,7 +138,10 @@ def auth_set(APP, auth):
         g.auth = auth
         g.oidc_id_token = None
         if not auth:
-            g.auth = munch.Munch(logged_in=False, user=None)
+            g.auth = munch.Munch(logged_in=False)
+            g.user = None
+        else:
+            g.user = auth.user
 
     if flask._app_ctx_stack.top is None:
         # App context isn't pushed yet
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index 50c5723..cc576c7 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -53,7 +53,7 @@ def get_visible_widgets(hub):
     from hubs.widgets import registry
     widgets = {"left": [], "right": []}
     try:
-        user = flask.g.auth.user
+        user = flask.g.user
     except AttributeError:
         user = None
     for widget in hub.widgets:
@@ -166,7 +166,7 @@ def require_hub_access(action, url_param="name", json=False):
             hub_name = kwargs[url_param]
             hub = get_hub(hub_name, load_config=True)
             try:
-                user = flask.g.auth.user
+                user = flask.g.user
             except AttributeError:
                 user = None
             if not hub.allows(user, action):
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 0616f05..4a7c6e7 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -193,7 +193,7 @@ def hub_config_get(hub):
             "role": assoc.role,
         }
         if (assoc.role == "owner" and
-                assoc.user.username == flask.g.auth.user.username):
+                assoc.user.username == flask.g.user.username):
             user["locked"] = True
         result["result"]["users"][assoc.role].append(user)
     return result
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 13e1313..e33c638 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -12,7 +12,7 @@ from hubs.utils.views import login_required, get_hub, get_sse_url
 @app.route('/stream/')
 @login_required
 def stream():
-    username = flask.g.auth.user.username
+    username = flask.g.user.username
     hub = get_hub(username)
     return flask.render_template(
         'stream.html',
@@ -24,7 +24,7 @@ def stream():
 @app.route('/stream/existing')
 @login_required
 def stream_existing():
-    username = flask.g.auth.user.username
+    username = flask.g.user.username
     feed = hubs.feed.Notifications(username)
     existing = feed.get()  # TODO: paging?
     # Right now, stream and actions are the same.
@@ -38,7 +38,7 @@ def stream_existing():
 @app.route('/stream/saved/', methods=['GET', 'POST'])
 @login_required
 def saved_notifs():
-    user = flask.g.auth.user
+    user = flask.g.user
     if flask.request.method == "GET":
         saved = hubs.models.SavedNotification.by_username(user.username)
         return flask.jsonify(dict(
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index 780a3d4..98fef57 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -94,7 +94,7 @@ class Username(Validator):
     @classmethod
     def to_string(cls, value):
         if value is None and flask.g.auth.logged_in:
-            return flask.g.auth.user.username
+            return flask.g.user.username
         return value
 
 
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index cd2810f..2f956bf 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -105,7 +105,7 @@ class WidgetView(View):
         """
         instance = self._get_instance(*args, **kwargs)
         try:
-            user = flask.g.auth.user
+            user = flask.g.user
         except AttributeError:
             user = None
         if not instance.allows(user, self.permission):

